#include <stdio.h>
#include <time.h> 	/* CLOCKS_PER_SEC*/
#include <asm/param.h> 	/* HZ */

static __inline__ void __delay(int loops)  /* <asm/delay.h> */
{
   __asm__ volatile (
      ".align 2,0x90
      1:	decl %0
      		jns 1b":
      :"a" (loops)
      :"ax");
}

void main()
{

   unsigned long ticks, loops_per_sec = 1;

   printf("Calibrating delay loop.. ");
   fflush(stdout);

   while ((loops_per_sec <<= 1))
   {
      ticks = clock();
      while (ticks == clock())	/* pockej na zacatek "tiku"*/
	 ;
      ticks = clock();
      __delay(loops_per_sec);
      ticks = clock() - ticks;
      if (ticks >= CLOCKS_PER_SEC)
      {
	 loops_per_sec = (loops_per_sec / ticks) * HZ;
	 printf("ok - %lu.%02lu BogoMIPS\n",
	    loops_per_sec/500000,
	    (loops_per_sec/5000) % 100);
	 return;
      }
   }
   printf("failed\n");
}
